Morph subclass: #BullsEyeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!BullsEyeMorph commentStamp: '<historical>' prior: 0!
A Morph that looks vaguely like a Bull's Eye.!


!BullsEyeMorph methodsFor: 'drawing' stamp: 'ls 6/12/2001 00:41'!
drawOn: aCanvas
	| dotBounds |
	aCanvas
		fillOval: self bounds
		color: self color.

	dotBounds :=
		(self bounds scaleBy: 1/2)
			center: self center.

	aCanvas
		fillOval: dotBounds
		color: Color red
		borderWidth: 1
		borderColor: Color black.! !


!BullsEyeMorph methodsFor: 'geometry' stamp: 'ls 6/12/2001 00:39'!
containsPoint: aPoint
	^(EllipseMorph new bounds: self bounds) containsPoint: aPoint! !


Morph subclass: #ClickCountingMorph
	instanceVariableNames: 'redClicks yellowClicks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!ClickCountingMorph commentStamp: '<historical>' prior: 0!
A morph that counts the number of times it is clicked with the red and yellow mouse buttons.!


!ClickCountingMorph methodsFor: 'initialization' stamp: 'ls 6/12/2001 01:16'!
initialize
	super initialize.
	redClicks := 0.
	yellowClicks := 0.! !


!ClickCountingMorph methodsFor: 'drawing' stamp: 'ls 6/12/2001 01:18'!
drawOn: aCanvas
	aCanvas frameRectangle: self bounds width: 1 color: self color.
	aCanvas text: (redClicks printString, ' red') bounds: (self bounds translateBy: 3@3) font: nil color: self color.
	aCanvas text: (yellowClicks printString, ' yellow') bounds: (self bounds translateBy: 3@13) font: nil color: self color.
! !


!ClickCountingMorph methodsFor: 'event handling'!
handlesMouseDown: t1 
	^ true! !

!ClickCountingMorph methodsFor: 'event handling' stamp: 'zz 1/16/2002 12:36'!
mouseDown: evt 
	"Compte le nombre de click souris"
	evt redButtonPressed
		ifTrue: [redClicks _ redClicks + 1].
	evt yellowButtonChanged
		ifTrue: [yellowClicks _ yellowClicks + 1].

	"Notifier que notre apparence  chang"
	self changed! !


Morph subclass: #CrossMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!CrossMorph commentStamp: '<historical>' prior: 0!
A morph that looks like a cross.  Or, at least it *should* look like a cross.  Can you fix it?!



Morph subclass: #FollowerMorph
	instanceVariableNames: 'morphToFollow '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!FollowerMorph commentStamp: '<historical>' prior: 0!
A morph that follows around another morph.  Or at least, it should -- can you fix it?
!


!FollowerMorph methodsFor: 'initialization' stamp: 'ls 6/12/2001 01:50'!
morphToFollow: aMorph
	"set which morph this morph should follow around the screen"
	morphToFollow := aMorph! !


Morph subclass: #KeyControlledMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!KeyControlledMorph commentStamp: '<historical>' prior: 0!
A morph  that moves around according to key presses.  Or at least it should.  Can you fix it?!



Morph subclass: #LetterShowingMorph
	instanceVariableNames: 'theLetter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!LetterShowingMorph commentStamp: '<historical>' prior: 0!
A morph that displays the last character typed by the user while pointing at the morph.!


!LetterShowingMorph methodsFor: 'initialization' stamp: 'ls 6/12/2001 01:29'!
initialize
	super initialize.
	theLetter := $A.! !


!LetterShowingMorph methodsFor: 'drawing' stamp: 'ls 6/12/2001 01:31'!
drawOn: aCanvas
	aCanvas frameRectangle: self bounds width: 1 color: self color.
	aCanvas
		text: theLetter asString
		bounds: (self topLeft + (10@10) corner: self bottomRight)
		font: nil
		color: self color.! !


!LetterShowingMorph methodsFor: 'the letter' stamp: 'ls 6/12/2001 01:32'!
newLetter: aCharacter
	"change the letter that is being displayed"
	theLetter := aCharacter.
	self changed.! !


!LetterShowingMorph methodsFor: 'event handling' stamp: 'ls 6/12/2001 01:38'!
handleKeystroke: evt
	self newLetter: evt keyCharacter! !

!LetterShowingMorph methodsFor: 'event handling' stamp: 'ls 6/12/2001 01:40'!
handlesMouseOver: evt
	^true! !

!LetterShowingMorph methodsFor: 'event handling' stamp: 'zz 1/16/2002 13:06'!
mouseEnter: evt
	"Rcupre les vnements du clavier"
	evt hand newKeyboardFocus: self.
! !

!LetterShowingMorph methodsFor: 'event handling' stamp: 'zz 1/16/2002 13:06'!
mouseLeave: evt
	"Ignorer les vnements du clavier"
	evt hand newKeyboardFocus: nil.! !


Morph subclass: #ToggleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LearnMorphic'!
!ToggleMorph commentStamp: '<historical>' prior: 0!
A morph that switches between white and black when it is clicked with the yellow button.  Well, at least, it *should* swtich back and forth, but it doesn't yet.  Can you finish this class?!

